﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Editors;
using Infragistics.Windows.DataPresenter;

namespace WpfApplication1
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            List<DhpComboItem> itemList = new List<DhpComboItem>() {
                new DhpComboItem(1, "one"),
                new DhpComboItem(2, "two"),
                new DhpComboItem("drei", "three"),
                new DhpComboItem(4, "four")
            };

            ComboBoxItemsProvider provider = new ComboBoxItemsProvider();
            provider.ItemsSource = itemList;
            //Removed so that item DhpComboItem is passed to converter
            //provider.ValuePath = "Value";

            //REPLACE DisplayMemberPath with DisplayTextConverter 
            //provider.DisplayMemberPath = "LabelText";
            //provider.DisplayMemberPath = "DisplayText";

            //this.xamComboEditor1.ValueType = typeof(object);
            this.xamComboEditor1.ItemsProvider = provider;
           
            this.xamComboEditor1.DropDownClosed+=new EventHandler<RoutedEventArgs>(xamComboEditor1_DropDownClosed);

            this.xamComboEditor1.SelectedIndex = 0;        
        }

        
        void xamComboEditor1_DropDownClosed(object sender, RoutedEventArgs e)
        {
            // Forcing end of editmode so that converted value is visible in text block
            xamComboEditor1.IsInEditMode = false;
        }
        
    }

    public class DhpComboItem
    {
        public DhpComboItem(object value, string labelText)
        {
            Value = value;
            LabelText = labelText;
        }

        public object Value { get; set; }

        public string LabelText { get; set; }

        public string DisplayText
        {
            get
            {
                string displayText = string.Empty;

                if (Value != null)
                    displayText = Value.ToString() + "\t";

                return displayText + LabelText;
            }
        }
    }
}